Subject: Re: bug#59531: 29.0.50: An alternative to `string-to-number` which throws an error (or returns a NIL value) when input is non-parseable as number

From: Jean Louis <[email-masked]>
Date: Thu, 24 Nov 2022 13:08:20 +0300

* Ramesh Nedunchezian <[email-masked]> [2022-11-24 09:22]:
> `string-to-number` returns ZERO if the input is not a number.  
> 
> 
> This return value is not very helpful.  The choice of a number ZERO as "Not A Number" doesn't help one to distinguish between the following two cases
> 
> (1) Input was a valid number, and it parses to number zero
> 
> (2) Input was NOT a valid number, and it was forcibly reported as ZERO
> 
> Consider amending `string-to-number` to throw an error (or return NIL) when the input is not parseable as a number, or providing an alternative API to validate numbers.  I am trying to parse some fields in an org table, and see if the field value is a number or not;
> 
> If there is already an alternative to what I am trying to
> accomplish, I would appreciate a recipe.

I had the same problem, so I have solved it this way.

(defun string-is-number-p (s)
  "Return number only if string is actual number, otherwise NIL."
  (let* ((s (string-trim s)))
    (cond ((seq-empty-p s) nil)
	  ((string-match "[^0123456789\\.-]" s) nil)
	  ((string-match "-" s 1) nil)
	  ((numberp (string-to-number s)) (string-to-number s)))))

As in my case I liketo know that string is really representing number
and nothing else.

(string-is-number-p "Hello") ➜ nil
(string-is-number-p "") ➜ nil
(string-is-number-p "0") ➜ 0
(string-is-number-p "0a") ➜ nil
(string-to-number "0a") ➜ 0
(string-is-number-p "0.1") ➜ 0.1
(string-is-number-p "-2.5121212") ➜ -2.5121212

My function may not be perfect.

--
Jean

Take action in Free Software Foundation campaigns:
https://www.fsf.org/campaigns

In support of Richard M. Stallman
https://stallmansupport.org/